#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Objective: to detect numbers that are vulnerable to __allocate_array(..).
 *
 * Mainly about the effects of "imull %edx, %eax".
 * With 3 assumptions for good effects to research.
 * 
 * All quick & dirty by J.C. Pizarro
 */

size_t my_num, my_size, my_max_num;
void* mynewXX(size_t size) {
   unsigned long long mult;
   
   if (my_num > my_max_num) {
      // size is ~size_t(0)
   } else {
      if (size > 200) return NULL; // 3rd assumption of that used size <= 200 bytes of memory
      mult = (unsigned long long)my_size * (unsigned long long)my_num;
      if ((mult >= 0x0000000080000000ULL) || (((unsigned int)size) >= 0x80000000)
       || (mult > size)) {
	 printf("oh!: num=%u; size=%u; max_num=0x%08X; num*size=%u (0x%08X); long=%llu (0x%08X%08X)\n",
		my_num,
		my_size,
		my_max_num,
		size,size,
		mult,((unsigned int)(mult>>32)),((unsigned int)(mult&~0)));
	 fflush(stdout);
      }
   }
   return NULL;
}

void *__allocate_array(size_t num, size_t size, size_t max_num) {
      if (num > max_num) return mynewXX(~size_t(0));
      return mynewXX(size*num);
}

void randattack_allocate_array_start_until_infinity(void) {
   srand(time(NULL));
   while(1) {
      my_num = rand();
      my_size = rand();
      my_max_num = (rand() << 29) + ((~0)>>(32-29));
      my_size &= 0x0000003F; // 1st assumption of that my_size <= 63 bytes of element
      if (my_num <= my_max_num)   // 2nd assumption of that my_num is <= my_max_num
         __allocate_array(my_num,my_size,my_max_num);
   }
}

int main(int argc,char *argv[]) {
   randattack_allocate_array_start_until_infinity();
}
